/* 2002/8/4
 *
 * linux_thread_fix.c - LinuxˤޥåɤΥץ륳ɡ׽
 *
 * [ưĶ]
 *   RedHat Linux 7.2
 *   gcc 2.96
 *
 * [ѥˡ]
 * # gcc -lpthread linux_thread_fix.c
 *
 */

#include <stdio.h>
#include <pthread.h>
#include <unistd.h>

#define TH_MAX 5    /* åɤ򵯤 */
#define MAX 10      /*  */

int g_value[MAX];    /* åɴ֤Ƕͭǡ */
int g_count[TH_MAX]; /* åγͥǡ */

pthread_mutex_t lock;  /* mutex֥ */


/* åɥ롼 */
void *thread_func(void *arg)
{
	int i, j, k;
	int argv = *(int *)arg;

	pthread_mutex_lock(&lock);  /* mutexå */

	for (i = 0 ; i < MAX ; i++) {
		g_value[i] = argv + i;
	}

	for (i = 0 ; i < MAX ; i++) {
		printf("[%d]=%-2d ", i, g_value[i]);
	}
	printf("\n");

	pthread_mutex_unlock(&lock); /* mutå */

	pthread_exit(0);  /* åɽλؼ */
	return NULL;
}


/* ᥤؿ */
int main(void)
{
	pthread_t hd[TH_MAX];   /* åID */
	int i, num, err;

	pthread_mutex_init(&lock, NULL);  /* mutex֥Ȥν */

	num = TH_MAX;
	for (i = 0 ; i < TH_MAX ; i++) {
		g_count[i] = i;

		/* åɤ */
		err = pthread_create(&hd[i], NULL, thread_func, &g_count[i]);
		if (err != 0) {  /* å */
			printf("err %d\n", err);
			num = i;
			goto error;
		}
	}

error:;
	if (num > 0) {
		/* åɤνλԤ碌 */
		for (i = 0 ; i < num ; i++) {
			pthread_join(hd[i], NULL);
		}
	}

	pthread_mutex_destroy(&lock); /* mutex֥Ȥβ */

	return 0;
}


